<template>
  <div class="w-editor" @click.right.stop>
    <WEmptyTextHint v-if="isShowEmptyTextHint" />
    <div
      v-show="editor"
      class="editor-topbar"
      :class="{
        'unset-top-border': isShowEmptyTextHint,
        active: isShowToolbar,
      }"
    >
      <WToolbar v-if="isShowToolbar" :editor="editor" />
    </div>
    <div class="editor j-scrollbar">
      <slot name="reply" />
      <EditorContent
        :editor="editor"
        class="editor-content"
        :class="{ 'full-size': isShowToolbar }"
      />
    </div>
  </div>
  <div class="bottom-toolbar">
    <div class="actions-left">
      <WButton
        :active="isShowToolbar"
        title="Formatting"
        @click="toggleToolbar"
        @keydown.enter="toggleToolbar"
        @keydown.space="toggleToolbar"
      >
        <JIcon icon="format" container-size size="16px" />
      </WButton>
    </div>
    <div class="actions-right">
      <template v-if="editMode">
        <WButton
          title="Cancel"
          @click="$emit('cancel')"
          @keydown.enter="$emit('cancel')"
          @keydown.space="$emit('cancel')"
        >
          <JIcon icon="closeOutline" container-size size="16px" />
        </WButton>
        <WButton title="Save" @click="saveEdit" @keydown.enter="saveEdit">
          <JIcon icon="save" container-size size="16px" />
        </WButton>
      </template>
      <template v-else>
        <WButton
          title="Send"
          @click="onSendMessage"
          @keydown.enter="onSendMessage"
          @keydown.space="onSendMessage"
        >
          <JIcon icon="send" container-size size="16px" />
        </WButton>
      </template>
    </div>
  </div>
</template>

<script setup lang="ts">
import {
  defineProps,
  defineEmits,
  defineExpose,
  onUnmounted,
  watch,
  ref,
  nextTick,
} from 'vue';
import { useEditor, EditorContent } from '@tiptap/vue-3';
import StarterKit from '@tiptap/starter-kit';
import Underline from '@tiptap/extension-underline';
import TextAlign from '@tiptap/extension-text-align';
import Placeholder from '@tiptap/extension-placeholder';
import Link from '@tiptap/extension-link';
import { JIcon } from '@new-jira-clone/ui/src/components';
import WToolbar from './WToolbar.vue';
import WButton from './WButton.vue';
import WEmptyTextHint from './WEmptyTextHint.vue';

const props = defineProps({
  modelValue: {
    type: String,
    default: '',
  },
  toolbar: {
    type: Boolean,
    default: false,
  },
  editMode: {
    type: Boolean,
    default: false,
  },
});

const emits = defineEmits<{
  (event: 'send', value: { html: string; text: string }): void;
  (event: 'save', value: { html: string; text: string }): void;
  (event: 'toolbar', value: boolean): void;
  (event: 'cancel'): void;
  (event: 'update:modelValue', value: { html: string; text: string }): void;
}>();

defineExpose({
  setFocus,
});

const isShowToolbar = ref(props.toolbar);
const isShowEmptyTextHint = ref(false);

const editor = useEditor({
  content: props.modelValue,
  extensions: [
    StarterKit,
    Underline,
    Link,
    TextAlign.configure({
      types: ['heading', 'paragraph'],
    }),
    Placeholder.configure({
      placeholder: 'Enter your message',
    }),
  ],
  onUpdate: () => {
    if (!editor.value) return;

    // HTML
    emits('update:modelValue', {
      html: editor.value.getHTML(),
      text: editor.value.getText(),
    });

    // JSON
    // emits('update:modelValue', editor.value.getJSON())
  },
  editorProps: {
    handleDOMEvents: {
      keydown: (_, event) => {
        if (event.key === 'Enter' && isShowToolbar.value === false) {
          if (props.editMode) {
            saveEdit();
          } else {
            onSendMessage();
          }
          event.preventDefault();
        }
      },
    },
  },
});

const runCloseEmptyTextHintTimeout = () => {
  setTimeout(() => {
    isShowEmptyTextHint.value = false;
  }, 4000);
};

const showEmptyTextHint = () => {
  if (isShowEmptyTextHint.value === false) {
    runCloseEmptyTextHintTimeout();
    isShowEmptyTextHint.value = true;
  }
};

async function onSendMessage() {
  if (!editor.value) return;

  const text = editor.value.getText();

  if (text === '' || text.trim() === '') {
    showEmptyTextHint();
    return;
  }

  emits('send', {
    html: editor.value.getHTML(),
    text: editor.value.getText(),
  });

  await nextTick();

  setFocus();
}

function saveEdit(): void {
  if (!editor.value) return;

  const text = editor.value.getText();

  if (text === '' || text.trim() === '') {
    showEmptyTextHint();
    return;
  }

  emits('save', {
    html: editor.value.getHTML(),
    text: text,
  });
}

function toggleToolbar(): void {
  isShowToolbar.value = !isShowToolbar.value;
  setFocus();
  emits('toolbar', isShowToolbar.value);
}

function setFocus() {
  setTimeout(() => {
    if (editor.value) {
      editor.value.view.dom.focus();
    }
  });
}

watch(
  () => props.modelValue,
  (newValue) => {
    if (!editor.value) return;

    // HTML
    const isSame = editor.value.getHTML() === newValue;

    // JSON
    // const isSame = JSON.stringify(editor.value.getJSON()) === JSON.stringify(value)

    if (isSame) {
      return;
    }

    editor.value.commands.setContent(newValue, false);
  }
);

watch(
  () => props.toolbar,
  (newValue) => {
    isShowToolbar.value = newValue;
  }
);

onUnmounted(() => {
  editor.value?.destroy();
});
</script>

<style scoped lang="scss">
.w-editor {
  position: relative;
  z-index: 1;
  background-color: var(--j-app-bg);
}

.editor {
  padding: 10px 16px 8px 12px;
  max-height: 270px;
  border: 1px solid rgb(var(--j-divider-color));
  border-top: none;
  border-radius: 0 0 4px 4px;
  background-color: #fff;
  font-size: 14px;

  &:not(.full-size) {
    border-top: none;
  }

  :deep(.editor-content) {
    min-height: 21px;

    * {
      margin: 0;
      padding: 0;
      outline: none;
    }
  }

  .full-size {
    min-height: 100px;
  }

  :deep(.ProseMirror) {
    /* Placeholder (at the top) */
    p.is-editor-empty:first-child::before {
      content: attr(data-placeholder);
      float: left;
      color: #adb5bd;
      pointer-events: none;
      height: 0;
    }
  }
}

.bottom-toolbar {
  display: flex;
  justify-content: space-between;
  padding: 4px 9px;
}

.editor-topbar {
  padding-bottom: 2px;
  border: 1px solid rgb(var(--j-divider-color));
  border-radius: 4px 4px 0 0;
  border-bottom: none;

  &.unset-top-border {
    border-radius: 0;
  }

  &.active {
    // TODO: add css vairable
    background-color: #f5f5f5;
  }
}
</style>
